/*
	This file is part of CrabEmu.

	Copyright (C) 2005 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#import <Cocoa/Cocoa.h>
#import "EmuView.h"

#include <time.h>
#include <sys/time.h>
#include "sms.h"

EmuView *theview;
extern int sms_running;

static unsigned long long getMilliseconds()	{
	struct timeval tv;
	unsigned long long rv;

	gettimeofday(&tv, NULL);

	rv = tv.tv_sec * 1000;
	rv += tv.tv_usec / 1000;

	return rv;
}

void emu_loop()	{
	int frames = 0;
	unsigned long long ms = getMilliseconds();

	sms_running = 1;

	while(sms_running == 1)	{
		sms_frame();
		[theview setNeedsDisplay: YES];
		frames++;

		while(ms + 16 > getMilliseconds()) ;

		ms = getMilliseconds();
	}

	sms_running = 0;
}

int main(int argc, char *argv[])	{
    return NSApplicationMain(argc,  (const char **) argv);
}
