/*
	This file is part of CrabEmu.

	Copyright (C) 2005 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include "smsz80.h"

z80_t *cpuz80;

int sms_z80_init()	{
	void z80_reset_alt(z80_t *cpu);
	cpuz80 = (z80_t *)malloc(sizeof(z80_t));

	if(cpuz80 == NULL)	{
		fprintf(stderr, "Out of memory while initializing Z80\n");
		return -1;
	}

	z80_init(cpuz80);
	z80_reset(cpuz80);

	z80_set_memwrite(cpuz80, sms_mem_write);
	z80_set_memread(cpuz80, sms_mem_read);
	z80_set_portwrite(cpuz80, sms_port_write);
	z80_set_portread(cpuz80, sms_port_read);

	return 0;
}

int sms_z80_shutdown()	{
	free(cpuz80);

	return 0;
}

void sms_z80_reset()	{
	z80_reset(cpuz80);
}

void sms_z80_irq()	{
	z80_pulse_irq(cpuz80);
}

void sms_z80_nmi()	{
	z80_pulse_nmi(cpuz80);
}

void sms_z80_run(int cycles)	{
	z80_execute(cpuz80, cycles);
}
