/*
	This file is part of CrabEmu.

	Copyright (C) 2005, 2006 Lawrence Sebald

	CrabEmu is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	CrabEmu is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CrabEmu; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef EMUCONTROLLER_H
#define EMUCONTROLLER_H

#import <Cocoa/Cocoa.h>

@class NSOpenGLContext;

@interface EmuController : NSObject
{
    IBOutlet NSMenuItem *noise;
    IBOutlet NSMenuItem *pause;
    IBOutlet NSMenuItem *PSG;
    IBOutlet NSMenuItem *tone0;
    IBOutlet NSMenuItem *tone1;
    IBOutlet NSMenuItem *tone2;
    IBOutlet NSPanel *virtKeyboard;
    IBOutlet NSPanel *prefWindow;

    NSUserDefaults *prefs;
    NSString *buttonmap;
}

- (void)awakeFromNib;
- (void)dealloc;

- (IBAction)enableNoise:(id)sender;
- (IBAction)enablePSG:(id)sender;
- (IBAction)enableTone0:(id)sender;
- (IBAction)enableTone1:(id)sender;
- (IBAction)enableTone2:(id)sender;
- (IBAction)loadMasterRom:(id)sender;
- (IBAction)prefGGStart:(id)sender;
- (IBAction)prefSms1B1:(id)sender;
- (IBAction)prefSms1B2:(id)sender;
- (IBAction)prefSms1Down:(id)sender;
- (IBAction)prefSms1Left:(id)sender;
- (IBAction)prefSms1Reset:(id)sender;
- (IBAction)prefSms1Right:(id)sender;
- (IBAction)prefSms1Up:(id)sender;
- (IBAction)prefSms2B1:(id)sender;
- (IBAction)prefSms2B2:(id)sender;
- (IBAction)prefSms2Down:(id)sender;
- (IBAction)prefSms2Left:(id)sender;
- (IBAction)prefSms2Reset:(id)sender;
- (IBAction)prefSms2Right:(id)sender;
- (IBAction)prefSms2Up:(id)sender;

- (unichar)runVirtKeyboard;
- (void)endVirtKeyboard:(unichar)character;

- (void)masterEmuThread:(id)junk;
- (void)pauseEmulation:(id)sender;

- (void)updateButtonMapFromString:(NSString *)str;
- (NSString *)buttonMap;

@end

#endif
